﻿Type=Class
Version=4.19
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Custom View class - ButtonTextField

#DesignerProperty: Key: FieldValue, Displayname: FieldValue, Fieldtype: String, Defaultvalue: Value, Description: Select a file.

Private Sub Class_Globals
	Private fx As JFX
	Private EventName As String 'ignore
	Private CallBack As Object 'ignore
	Private tfField As TextField
	Private FieldValue As String
	Private btnOpen As Button
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	tfField.Initialize("tfField")
	tfField.Style = Lbl.Style
	Base.AddNode(tfField, 0, 0, 0, 0)
	btnOpen.Initialize("btnOpen")
	CSSUtils.SetBackgroundImage(btnOpen, File.DirAssets, "open.png")
	Base.AddNode(btnOpen, 0,0,0,0) 
	'tfField.Text = Props.Get("FieldValue")		'This can be used to set the initial value taken from the key properties
	tfField.TooltipText = "Select a File"
	tfField.PromptText = "Select a File"
	Base.Style = "-fx-border-style: none;"
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	tfField.SetLayoutAnimated(0, 4, 0, Width - 25, Height)
	btnOpen.SetLayoutAnimated(0, Width - 25, 0, 25, Height)
End Sub

Public Sub GetFieldValue As String
	Return FieldValue
End Sub

Public Sub SetFieldValue(Value As String)
	tfField.Text = Value
End Sub

Private Sub tfField_TextChanged (Old As String, New As String)
	FieldValue = New
End Sub

Private Sub btnOpen_Action
	Dim fc As FileChooser
	Dim fileSelected As String			'File selected. If selected full path is returned else ""
  	fc.Initialize                       'Init! Do not forget
  	fc.InitialDirectory = File.DirApp   'Set starting folder
  	fc.Title = "Select a File"
  	fileSelected = fc.ShowOpen(Main.MainForm)  	'Show the dialog and select
	If fileSelected.Length > 0 Then SetFieldValue(fileSelected)
End Sub
